Index: src/main/java/com/example/rezevirajmasa/demo/web/controller/RestaurantController.java
===================================================================
--- src/main/java/com/example/rezevirajmasa/demo/web/controller/RestaurantController.java	(revision d24f17cb212e43f94a77a44d655ba10b4b8143d2)
+++ src/main/java/com/example/rezevirajmasa/demo/web/controller/RestaurantController.java	(revision d24f17cb212e43f94a77a44d655ba10b4b8143d2)
@@ -0,0 +1,109 @@
+package com.example.rezevirajmasa.demo.web.controller;
+
+import com.example.rezevirajmasa.demo.model.Customer;
+import com.example.rezevirajmasa.demo.model.Restaurant;
+import com.example.rezevirajmasa.demo.model.TableEntity;
+import com.example.rezevirajmasa.demo.service.CustomerService;
+import com.example.rezevirajmasa.demo.service.ReservationService;
+import com.example.rezevirajmasa.demo.service.RestaurantService;
+import com.example.rezevirajmasa.demo.service.TableService;
+import net.sourceforge.htmlunit.xpath.operations.Mod;
+import org.springframework.boot.Banner;
+import org.springframework.security.core.Authentication;
+import org.springframework.ui.Model;
+import org.springframework.stereotype.Controller;
+import org.springframework.web.bind.annotation.*;
+import org.springframework.ui.Model;
+import java.math.BigDecimal;
+import java.time.LocalDateTime;
+import java.util.HashSet;
+import java.util.List;
+import java.util.Set;
+
+@Controller
+public class RestaurantController {
+    private final RestaurantService restaurantService;
+    private final TableService tableService;
+
+    public RestaurantController(RestaurantService restaurantService, TableService tableService) {
+        this.restaurantService = restaurantService;
+        this.tableService = tableService;
+    }
+
+    @GetMapping("/restaurants")
+    public String showRestaurants(@RequestParam(required = false) String search, Model model) {
+        List<Restaurant> restaurantList;
+        if(search == null) {
+            restaurantList = this.restaurantService.listall();
+        } else {
+            restaurantList = restaurantService.listRestaurantBy(search);
+        }
+
+        for (Restaurant restaurant : restaurantList) {
+            // Initialize a set to store unique capacities for this restaurant
+            Set<Integer> uniqueCapacities = new HashSet<>();
+
+            // Populate uniqueCapacities with unique capacity values for tables in this restaurant
+            for (TableEntity table : restaurant.getTablesList()) {
+                uniqueCapacities.add(table.getCapacity());
+            }
+
+            // Add uniqueCapacities to the model for this restaurant
+            model.addAttribute("uniqueCapacities_" + restaurant.getRestaurantId(), uniqueCapacities);
+        }
+        model.addAttribute("bodyContent", "restaurants");
+        model.addAttribute("restaurants", restaurantList);
+        return "index";
+    }
+
+    @GetMapping("/restaurants/{tableNumber}")
+    public String reserveTable(@PathVariable Long tableNumber, Model model) {
+        TableEntity tableEntity = tableService.findById(tableNumber);
+        Restaurant restaurant = tableEntity.getRestaurant();
+
+        model.addAttribute("table", tableEntity);
+        model.addAttribute("restaurant", restaurant);
+
+        model.addAttribute("bodyContent", "reservationConfirmation.html");
+
+        return "index";
+    }
+
+    @GetMapping("/restaurants/add")
+    public String showAddRestaurantForm(Model model) {
+        model.addAttribute("bodyContent", "restaurantForm");
+        return "index";
+    }
+
+    @PostMapping("/register-restaurant")
+    public String saveRestaurant(@RequestParam String name,
+                                 @RequestParam String cuisineType,
+                                 @RequestParam String address,
+                                 @RequestParam String phone,
+                                 @RequestParam String operatingHours,
+                                 @RequestParam BigDecimal rating,
+                                 @RequestParam int numberOfTables,
+                                 @RequestParam List<Integer> tableCapacities,
+                                 @RequestParam List<String> tableLocations,
+                                 @RequestParam List<String> tableSmokingAreas,
+                                 @RequestParam List<String> tableDescriptions,
+                                 @RequestParam String socialMediaLinks,
+                                 @RequestParam String website,
+                                 Model model) {
+
+        Restaurant restaurant = new Restaurant();
+        restaurant.setName(name);
+        restaurant.setCuisineType(cuisineType);
+        restaurant.setAddress(address);
+        restaurant.setPhone(phone);
+        restaurant.setOperatingHours(operatingHours);
+        restaurant.setRating(rating);
+        restaurant.setSocialMediaLinks(socialMediaLinks);
+        restaurant.setWebsite(website);
+
+        restaurantService.save(restaurant, numberOfTables, tableCapacities, tableLocations, tableSmokingAreas, tableDescriptions);
+        model.addAttribute("bodyContent", "restaurants");
+        return "redirect:/restaurants";
+    }
+
+}
Index: src/main/java/com/example/rezevirajmasa/demo/web/rest/AuthController.java
===================================================================
--- src/main/java/com/example/rezevirajmasa/demo/web/rest/AuthController.java	(revision e48199adf103ea72701a91722bdbf8cfb9732731)
+++ src/main/java/com/example/rezevirajmasa/demo/web/rest/AuthController.java	(revision d24f17cb212e43f94a77a44d655ba10b4b8143d2)
@@ -1,36 +1,9 @@
 package com.example.rezevirajmasa.demo.web.rest;
 
-import com.example.rezevirajmasa.demo.config.UserAuthProvider;
-import com.example.rezevirajmasa.demo.dto.CredentialsDto;
-import com.example.rezevirajmasa.demo.dto.SignUpDto;
-import com.example.rezevirajmasa.demo.dto.UserDto;
-import com.example.rezevirajmasa.demo.service.UserService;
-import lombok.RequiredArgsConstructor;
-import org.springframework.http.ResponseEntity;
-import org.springframework.web.bind.annotation.PostMapping;
-import org.springframework.web.bind.annotation.RequestBody;
+import org.springframework.beans.factory.annotation.Autowired;
+import org.springframework.security.authentication.AuthenticationManager;
 import org.springframework.web.bind.annotation.RestController;
 
-import java.net.URI;
-
-@RequiredArgsConstructor
 @RestController
 public class AuthController {
-    private final UserService userService;
-    private final UserAuthProvider userAuthProvider;
-    @PostMapping("/api/login")
-    public ResponseEntity<UserDto> login(@RequestBody CredentialsDto credentialsDto) {
-        UserDto user = userService.login(credentialsDto);
-        String token = userAuthProvider.createToken(user.getEmail());
-        user.setToken(token);
-
-        return ResponseEntity.ok(user);
-    }
-
-    @PostMapping("/api/register")
-    public ResponseEntity<UserDto> register(@RequestBody SignUpDto signUpDto) {
-        UserDto user = userService.register(signUpDto);
-        user.setToken(userAuthProvider.createToken(user.getEmail()));
-        return ResponseEntity.created(URI.create("/users/" + user.getId())).body(user);
-    }
 }
Index: src/main/java/com/example/rezevirajmasa/demo/web/rest/testController.java
===================================================================
--- src/main/java/com/example/rezevirajmasa/demo/web/rest/testController.java	(revision e48199adf103ea72701a91722bdbf8cfb9732731)
+++ src/main/java/com/example/rezevirajmasa/demo/web/rest/testController.java	(revision d24f17cb212e43f94a77a44d655ba10b4b8143d2)
@@ -1,30 +1,16 @@
 package com.example.rezevirajmasa.demo.web.rest;
 
-import com.example.rezevirajmasa.demo.dto.*;
-import com.example.rezevirajmasa.demo.mappers.UserMapper;
 import com.example.rezevirajmasa.demo.model.*;
-import com.example.rezevirajmasa.demo.model.exceptions.InvalidReservationException;
-import com.example.rezevirajmasa.demo.service.*;
-import com.example.rezevirajmasa.demo.service.impl.TokenService;
-import jakarta.servlet.http.HttpServletRequest;
-import jdk.jfr.consumer.RecordingStream;
+import com.example.rezevirajmasa.demo.service.CustomerService;
+import com.example.rezevirajmasa.demo.service.ReservationService;
+import com.example.rezevirajmasa.demo.service.RestaurantService;
+import com.example.rezevirajmasa.demo.service.TableService;
 import org.apache.coyote.Response;
-import org.apache.http.protocol.HTTP;
-import org.springframework.format.annotation.DateTimeFormat;
 import org.springframework.http.HttpStatus;
 import org.springframework.http.ResponseEntity;
-import org.springframework.security.core.Authentication;
-import org.springframework.security.core.annotation.AuthenticationPrincipal;
-import org.springframework.security.core.context.SecurityContextHolder;
-import org.springframework.security.core.parameters.P;
-import org.springframework.security.core.userdetails.UserDetails;
 import org.springframework.web.bind.annotation.*;
 
-import java.nio.file.attribute.UserPrincipal;
-import java.security.Principal;
 import java.time.LocalDateTime;
-import java.time.format.DateTimeFormatter;
-import java.util.*;
-import java.util.stream.Collectors;
+import java.util.List;
 
 @CrossOrigin(origins = "http://localhost:3000/")
@@ -32,20 +18,13 @@
 public class testController {
     private final RestaurantService restaurantService;
-    private final UserService userService;
+    private final CustomerService customerService;
     private final ReservationService reservationService;
-    private final ReservationHistoryService reservationHistoryService;
     private final TableService tableService;
-    private final MenuService menuService;
-    private final UserMapper userMapper;
-    private final TokenService tokenService;
-    public testController(RestaurantService restaurantService, UserService userService, ReservationService reservationService, ReservationHistoryService reservationHistoryService, TableService tableService, MenuService menuService, UserMapper userMapper, TokenService tokenService) {
+
+    public testController(RestaurantService restaurantService, CustomerService customerService, ReservationService reservationService, TableService tableService) {
         this.restaurantService = restaurantService;
-        this.userService = userService;
+        this.customerService = customerService;
         this.reservationService = reservationService;
-        this.reservationHistoryService = reservationHistoryService;
         this.tableService = tableService;
-        this.menuService = menuService;
-        this.userMapper = userMapper;
-        this.tokenService = tokenService;
     }
 
@@ -55,97 +34,49 @@
     }
 
-    //restaurants calls
-
-    @GetMapping("/api/restaurants")
-    public ResponseEntity<List<RestaurantDTO>> getAllRestaurants() {
-            return new ResponseEntity<List<RestaurantDTO>>(restaurantService.listall(), HttpStatus.OK);
+    @RequestMapping("/api/restaurants")
+    public ResponseEntity<List<Restaurant>> getAllRestaurants() {
+        return new ResponseEntity<List<Restaurant>>(restaurantService.listall(), HttpStatus.OK);
     }
 
-    @GetMapping("/api/restaurants/{restaurantId}")
-    public ResponseEntity<RestaurantDTO> getRestaurantById(@PathVariable Long restaurantId) {
-        RestaurantDTO restaurantDTO = restaurantService.findById(restaurantId);
-        return new ResponseEntity<>(restaurantDTO, HttpStatus.OK);
+    @RequestMapping("/api/restaurants/{restaurantId}")
+    public ResponseEntity<Restaurant> getRestaurantById(@PathVariable Long restaurantId) {
+        return new ResponseEntity<Restaurant>(restaurantService.findById(restaurantId), HttpStatus.OK);
     }
 
-    @PostMapping("/api/search")
-    public ResponseEntity<List<RestaurantDTO>> searchRestaurants(@RequestBody Map<String, Object> requestData) {
-        Optional<String> dateTimeOptional = Optional.ofNullable((String) requestData.get("dateTime"));
-        int partySize = Integer.parseInt(requestData.get("partySize").toString());
-        Optional<String> searchOptional = Optional.ofNullable((String) requestData.get("search"));
+//    Customer CALLS
 
-        String dateTime = dateTimeOptional.orElse(null);
-        String search = searchOptional.orElse(null);
-
-        LocalDateTime parsedDateTime = null;
-        DateTimeFormatter formatter = DateTimeFormatter.ofPattern("yyyy-MM-dd HH:mm");
-        if (dateTime != null) {
-            parsedDateTime = LocalDateTime.parse(dateTime, formatter);
-        }
-
-        List<RestaurantDTO> filteredRestaurants = restaurantService.findRestaurantsBySearchParams(parsedDateTime, partySize, search);
-
-        return new ResponseEntity<>(filteredRestaurants, HttpStatus.OK);
+    @RequestMapping("/api/customers")
+    public ResponseEntity<List<Customer>> getAllCustomers() {
+        return new ResponseEntity<List<Customer>>(customerService.listAll(), HttpStatus.OK);
     }
 
-    @PostMapping("/api/search/shortcut/{param}")
-    public ResponseEntity<List<RestaurantDTO>> searchByCuisineTypeShortcut(@PathVariable String param) {
-        List<RestaurantDTO> filteredRestaurants;
-        if(param != null && !param.isEmpty()) {
-            filteredRestaurants = restaurantService.findRestaurantsByCuisineType(param);
-        } else {
-            filteredRestaurants = restaurantService.listall();
-        }
-        return new ResponseEntity<List<RestaurantDTO>>(filteredRestaurants, HttpStatus.OK);
+    @RequestMapping("/api/customers/{id}")
+    public ResponseEntity<Customer> getCustomerById(@PathVariable Long id) {
+        return new ResponseEntity<Customer>(customerService.findById(id), HttpStatus.OK);
     }
 
-    @GetMapping("/api/cuisineTypes")
-    public ResponseEntity<List<String>> getAllCuisineTypes() {
-        List<String> cuisineTypes = restaurantService.findALlCuisineTypes();
-        return new ResponseEntity<>(cuisineTypes, HttpStatus.OK);
+    @PutMapping("/api/customers/edit/{id}")
+    public ResponseEntity<Customer> editCustomerById(@PathVariable Long id, @RequestBody Customer customer) {
+        return new ResponseEntity<Customer>(
+                customerService.updateCustomer(id, customer.getFirstName(), customer.getLastName(), customer.getEmail(), customer.getPassword(), customer.getPhone(), customer.getAddress(), customer.getMembershipLevel()),
+                HttpStatus.OK
+        );
     }
 
-    // User calls
-
-    @GetMapping("/api/user/{email}")
-    public ResponseEntity<User> getUserByEmail(@PathVariable String email)
-    {
-        User user = userService.findByMail(email);
-        return ResponseEntity.ok(user);
+    @PostMapping("/api/customers")
+    public ResponseEntity<Customer> saveCustomer(@RequestBody Customer customer) {
+        // Ensure that the role is set to ROLE_USER by default
+        customer.setRole(Role.ROLE_USER);
+        return new ResponseEntity<Customer>(
+                customerService.registration(customer),
+                HttpStatus.OK
+        );
     }
 
-//    Reservation Calls
-
-    @GetMapping("/api/reservations/by/{email}")
-    public ResponseEntity<List<ReservationDTO>> getReservations(@PathVariable String email) {
-        if (email == null || email.isEmpty()) {
-            return ResponseEntity.badRequest().build();
-        }
-        User user = userService.findByMail(email);
-        if (user == null) {
-            return ResponseEntity.notFound().build();
-        }
-
-        List<Reservation> reservations = reservationService.findReservationByUser(user);
-        List<ReservationDTO> reservationDTOs = reservations.stream()
-                .map(ReservationDTO::new)
-                .collect(Collectors.toList());
-
-        return ResponseEntity.ok(reservationDTOs);
-    }
-
-    @PostMapping("/api/reservations")
-    public ResponseEntity<?> createReservation(@RequestBody ReservationDTO reservation){
-    User user = userService.findByMail(reservation.getUserEmail());
-    Restaurant restaurant = restaurantService.findByIdRestaurant(reservation.getRestaurantId());
-        Reservation savedReservation = reservationService.makeReservationRest(reservation, user, restaurant);
-
-        return new ResponseEntity<>(savedReservation, HttpStatus.CREATED);
-    }
-
-    @GetMapping("/api/reservations/{reservationId}")
-    public ResponseEntity<ReservationDTO> getReservation(@PathVariable Long reservationId) {
-        Reservation reservation = reservationService.findById(reservationId);
-        if (reservation != null) {
-            return ResponseEntity.ok(new ReservationDTO(reservation));
+    @DeleteMapping("/api/customers/delete/{customerId}")
+    public ResponseEntity<Response> deleteCustomer(@PathVariable Long customerId) {
+        boolean deleted = customerService.deleteById(customerId);
+        if(deleted) {
+            return ResponseEntity.ok().build();
         } else {
             return ResponseEntity.notFound().build();
@@ -153,49 +84,54 @@
     }
 
-//    @GetMapping("/api/reservations/{restaurantId}")
-//    public ResponseEntity<List<Reservation>> getReservationsByRestaurant(@PathVariable Long restaurantId)
-//    {
-//        Restaurant restaurant = restaurantService.findByIdRestaurant(restaurantId);
-//        List<Reservation> reservations = reservationService.findAllByRestaurant(restaurant);
-//        return ResponseEntity.ok(reservations);
-//    }
+//    Reservation Calls
 
-    @GetMapping("/api/table-reservations/{tableId}")
-    public ResponseEntity<List<LocalDateTime>> tableReservations(@PathVariable Long tableId) {
-        TableEntity table = tableService.findByIdTable(tableId);
-        if (table == null) {
+    @GetMapping("/api/reservations")
+    public ResponseEntity<List<Reservation>> getReservations() {
+        return new ResponseEntity<List<Reservation>>(reservationService.listAll(), HttpStatus.OK);
+    }
+
+    @PostMapping("/api/reservations")
+    public ResponseEntity<Reservation> createReservation(@RequestBody Reservation reservation) {
+        reservation.setReservationDateTime(LocalDateTime.now());
+        Reservation savedReservation = reservationService.makeReservationRest(reservation);
+        return new ResponseEntity<>(savedReservation, HttpStatus.CREATED);
+    }
+
+    @GetMapping("/api/reservations/{reservationId}")
+    public ResponseEntity<Reservation> getReservation(@PathVariable Long reservationId) {
+        Reservation reservation = reservationService.findById(reservationId);
+        if (reservation != null) {
+            return ResponseEntity.ok(reservation);
+        } else {
             return ResponseEntity.notFound().build();
         }
-
-        List<Reservation> reservations = reservationService.reservationsForTable(table);
-        List<LocalDateTime> reservedTimes = reservations.stream()
-                .map(Reservation::getReservationDateTime)
-                .collect(Collectors.toList());
-
-        return ResponseEntity.ok(reservedTimes);
     }
 
-
-    @PostMapping("/api/reservations/{reservationId}/{email}")
+    @PostMapping("/api/reservations/{reservationId}")
     public ResponseEntity<Reservation> editReservation(@PathVariable Long reservationId,
-                                                       @RequestBody ReservationDTO reservationDTO,
-                                                       @PathVariable String email) {
-        User user = userService.findByMail(email);
-        Restaurant restaurant = restaurantService.findByIdRestaurant(reservationDTO.getRestaurantId());
-        if (!reservationDTO.getReservationID().equals(reservationId)) {
+                                                       @RequestBody Reservation reservation) {
+        if (!reservation.getReservationID().equals(reservationId)) {
             return ResponseEntity.badRequest().build();
         }
 
-        try {
-            Reservation updatedReservation = reservationService.updateReservation(reservationId, reservationDTO, user);
-            return ResponseEntity.ok(updatedReservation);
-        } catch (InvalidReservationException e) {
-            return ResponseEntity.status(409).body(null);
-        } catch (Exception e) {
-            return ResponseEntity.status(500).build();
+        Reservation savedReservation = reservationService.findById(reservationId);
+        if(!reservation.getCheckInTime().equals(savedReservation.getCheckInTime())) {
+            tableService.canceledTimeSlots(savedReservation.getTable().getId(), savedReservation.getCheckInTime());
         }
+
+        savedReservation.setReservationDateTime(LocalDateTime.now());
+        savedReservation.setCheckInTime(reservation.getCheckInTime());
+        savedReservation.setCheckOutTime(reservation.getCheckInTime().plusHours(2));
+        savedReservation.setPartySize(reservation.getPartySize());
+        savedReservation.setSpecialRequests(reservation.getSpecialRequests());
+        tableService.deleteTimeSlotsForReservation(reservation.getTable().getId(), reservation.getCheckInTime());
+
+        //moze da se vovede sistem za ako od 4ca doagjaat samo 2ca da se najde pomala masa po moznost ako ima u toj moment
+        //listaj samo slotovi za taa masa vo toj moment ili da ima da odbere od novo ama taka bolje nova rezevacij
+
+        Reservation updatedReservation = reservationService.makeReservationRest(savedReservation);
+        System.out.println("Saved reservation time: " + savedReservation.getCheckInTime());
+        return ResponseEntity.ok(updatedReservation);
     }
-
-
 
     @DeleteMapping("/api/reservations/delete/{reservationId}")
@@ -209,29 +145,10 @@
     }
 
-    @GetMapping("/api/reservations/past/{email}")
-    public ResponseEntity<List<Restaurant.ReservationHistory>> pastReservations(@PathVariable String email) {
-        User user = userService.findByMail(email);
-        return null;
+//    TableEntity Calls
+
+    @GetMapping("/api/tables/{tableId}")
+    public ResponseEntity<TableEntity> findTableById(@PathVariable Long tableId) {
+        return new ResponseEntity<TableEntity>(tableService.findById(tableId), HttpStatus.OK);
     }
 
-    // TableEntity Calls
-    @GetMapping("/api/tables/{tableId}")
-    public ResponseEntity<TableDTO> findTableById(@PathVariable Long tableId) {
-        TableDTO tableDTO = tableService.findById(tableId);
-        return new ResponseEntity<>(tableDTO, HttpStatus.OK);
-    }
-
-    // past reservation calls
-    @GetMapping("/api/past-reservations/{email}")
-    public ResponseEntity<List<Restaurant.ReservationHistory>> findPastReservationsByUser(@PathVariable String email) {
-        User user = userService.findByMail(email);
-        List<Restaurant.ReservationHistory> reservations = reservationHistoryService.findByUser(user);
-        return new ResponseEntity<>(reservations, HttpStatus.OK);
-    }
-
-    // menu calls
-    @GetMapping("/api/restaurant-menu/{restaurantId}")
-    public List<Menu> getMenuByRestaurantId(@PathVariable Long restaurantId) {
-        return menuService.getMenuByRestaurantId(restaurantId);
-    }
 }
